
#    MIDAS Httpd Service to provide Time Server

global env
source [file join $env(MIDASBASE) TclHttpd tcl MIDASDomainHandler.tcl]       ;#  load default support procedures

global MIDAS_TimeServer_Exists
set MIDAS_TimeServer_Exists 1


# Use namespaces to isolate our methods
namespace eval urn:TimeServer {

    proc GetTime {args} {
        set vl [do_GetTime]
        return [list [list ResponseCode int 0] [list Time string "$vl"] ]
    }

    proc do_GetTime {} {

       return "[date]"
    }

    # We have to publish the public methods...

     SOAP::export GetTime
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /TimeServer -namespace urn:TimeServer -uri urn:TimeServer]

proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/TimeServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessService $optsname $sock $args}
